/*
fact.c
*/

extern void adainit();
extern void adafinal();
extern long factorial( long N );

int main (int argc, char * argv [])
{
   long answer, value;

   if (argc < 2)
     {
       printf ("USAGE: %s <Natural range 0 .. 12>\n",
	       argv [0]);
       return 1;
     }   
   adainit();

   value = atol(argv[1]);

   if ( value >= 0 ) 
   {
      if ( value <= 12 ) 
      {
         answer = factorial(value);
         printf("\n  %2d! = %3d\n",value,answer);
      }
      else 
      {
         printf
	   ("\n  fact: input value too big (would cause overflow).\n");
      }
   }
   else 
   {
      printf("\n  fact: input must be strictly non-negative.\n");
   }
   
   adafinal();
   return 0;
}

